subroutine CalcGM2D( &
  & imax, jmax, y_LatWeight, xy_Arr2D, &
  & GM &
  & )

  use vtype_module

  implicit none

  integer , intent(in ) :: imax
  integer , intent(in ) :: jmax
  real(dp), intent(in ) :: y_LatWeight(1:jmax)
  real(dp), intent(in ) :: xy_Arr2D(0:imax-1, 1:jmax)
  real(dp), intent(out) :: GM


  ! Local variables
  !
  real(dp) :: y_ZM(1:jmax)
  integer  :: i
  integer  :: j


  do j = 1, jmax
    y_ZM(j) = 0.0d0
    do i = 0, imax-1
      y_ZM(j) = y_ZM(j) + xy_Arr2D(i,j)
    end do
    y_ZM(j) = y_ZM(j) / dble( imax )
  end do
  GM = 0.0d0
  do j = 1, jmax
    GM = GM + y_ZM(j) * y_LatWeight(j)
  end do
  GM = GM / 2.0d0


end subroutine CalcGM2D

!**************************************************************************

subroutine CalcGM3D( &
  & Grav, imax, jmax, kmax, y_LatWeight, xyr_Press, xyz_Arr3D, &
  & GM &
  & )

  use vtype_module

  implicit none

  real(dp), intent(in ) :: Grav
  integer , intent(in ) :: imax, jmax, kmax
  real(dp), intent(in ) :: y_LatWeight(1:jmax)
  real(dp), intent(in ) :: xyr_Press(0:imax-1, 1:jmax, 0:kmax)
  real(dp), intent(in ) :: xyz_Arr3D(0:imax-1, 1:jmax, 1:kmax)
  real(dp), intent(out) :: GM


  ! Local variables
  !
  real(dp) :: xy_Arr2D(0:imax-1, 1:jmax)
  integer  :: k


  xy_Arr2D = 0.0d0
  do k = 1, kmax
    xy_Arr2D = xy_Arr2D &
      & + xyz_Arr3D(:,:,k) * ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav
  end do

  call CalcGM2D( &
    & imax, jmax, y_LatWeight, xy_Arr2D, &
    & GM &
    & )


end subroutine CalcGM3D

!**************************************************************************
